import React, { Component } from 'react'
import ReactDOM from 'react-dom'
import _ from 'lodash';

import { createStore, applyMiddleware, combineReducers, compose } from 'redux'
import { Provider, connect } from 'react-redux'
// import { Form, Control, Errors, combineForms, actions } from 'react-redux-form'
import thunk from 'redux-thunk';
import createLogger from 'redux-logger';

import {
  Field,
  Fieldset,
  Errors,
  Control,
  Form,
  LocalForm,
  combineForms,
  actions,
  formReducer,
  modeled,
  controls
} from 'react-redux-form';


const initialUserState = {
  firstName: '',
  lastName: '',
  file: [],
};

const store = createStore(combineForms({
  user: initialUserState,
}), applyMiddleware(thunk, createLogger()));

const fv = (formats, file) => {
  return !file || !_.first(file) || _.indexOf(formats.split(',').map((i) => i.trim()), _.first(file).name.split('.').pop()) != -1;
}

class UserForm extends Component {
  render() {
    return (
      <Form model="user" onSubmit={v => console.log(v)}>
        <div className="field">
          <label>First name:</label>
          <Control.text model="user.firstName" />
        </div>

        <div className="field">
          <label>Last name:</label>
          <Control.text model="user.lastName" />
        </div>

        <div className="field">
          <label>File:</label>
           <Control.file
              model=".file"
              validators={{ format: fv.bind(this, 'png') }}/>
            <Errors model=".file" messages={{ format: 'Format Error' }} />

        </div>

        <button type="submit">
          Submit (check console)
        </button>
      </Form>
    )
  }
}

class App extends React.Component {
  render() {
    return (
      <Provider store={store}>
        <UserForm />
      </Provider>
    );
  }
}

ReactDOM.render(<App />, document.getElementById('app'));
